import sys
import dbus
from PyQt4 import QtCore, QtGui

class BatteryLevel(QtGui.QWidget):
  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)
    self.device=self.parent().parent().device

    try:
      battery=dbus.SystemBus().get_object("org.freesmartphone.odeviced", "/org/freesmartphone/Device/PowerSupply/battery")
      self.capacity=battery.GetCapacity(dbus_interface="org.freesmartphone.Device.PowerSupply")
      battery.connect_to_signal("Capacity", self.onCapacity)
    except:
      self.capacity=-1

  def onCapacity(self, capacity):
    self.capacity=capacity
    self.update()

  def resizeEvent(self, e):
    h=e.size().height()
    w=(h/3)*2
    self.resize(w, h)
    self.setMinimumWidth(w)

  def paintEvent(self, e):
    w=self.width()
    h=self.height()
    
    ch=h/3
    
    painter=QtGui.QPainter(self)
    painter.drawRect(1, ch, w-4, ch)
    painter.fillRect(w-3, ch+ch/4, 3, ch/2+1, QtGui.QBrush(QtCore.Qt.black))
    if self.capacity!=-1:
      col_out=QtGui.QColor(255-self.capacity, self.capacity, 0)
      col_in=QtGui.QColor(255-self.capacity*2.5, self.capacity*2.5, 0)
      wl=self.capacity*(w-5)/100
      gradient=QtGui.QLinearGradient(0, 0, w, ch)
      gradient.setColorAt(0, col_out);
      gradient.setColorAt(0.5, col_in);
      gradient.setColorAt(1, col_out);
      gradient.setStart(0, ch)
      gradient.setFinalStop(0, ch*2)
      painter.setBrush(gradient);
      painter.setPen(QtCore.Qt.NoPen)
      painter.drawRect(2, ch+1, wl, ch-1)

    painter.end()
