import sys
from PyQt4 import QtCore, QtGui

class BottomBar(QtGui.QWidget):
  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)

    self.keyboard_button=QtGui.QPushButton(QtGui.QIcon("core/icons/kxkb.png"), "", self)
    self.keyboard_button.setFocusPolicy(QtCore.Qt.NoFocus)
    self.keyboard_button.setFlat(1)

    self.left_button=None
    self.right_button=None

    QtCore.QObject.connect(self.keyboard_button,QtCore.SIGNAL("clicked()"), self.parent().showHideKeyboard)

    # TODO better geometry management
    self.setFixedHeight(30)

  def resizeEvent(self, e):
    self.updateGeometry()

  def updateGeometry(self):
    kw=30
    bw=(self.width()-kw)/2
    h=self.height()

    if(self.left_button):
      self.left_button.setGeometry(0, 0, bw, h)

    self.keyboard_button.setGeometry(bw, 0, kw, h)

    if(self.right_button):
      self.right_button.setGeometry(bw+kw, 0, self.width()-bw-kw, h)

  def setButtons(self, left_button, right_button, keyboard_enabled):
    if(self.left_button): self.left_button.hide()
    if(self.right_button): self.right_button.hide()
    self.left_button=left_button
    self.right_button=right_button

    if(left_button):
      left_button.setParent(self)
      left_button.show()
      
    if(right_button):
      right_button.setParent(self)
      right_button.show()
    
    self.keyboard_button.setEnabled(keyboard_enabled)

    self.updateGeometry()
