import sys
from PyQt4 import QtCore, QtGui

from core.auimd_widget import *
from mainmenu import *

class Home(QtGui.QWidget, AuimdWidget):

  class Wallpaper:
    def __init__(self, path, scaled):
      self.path=path
      self.scaled=scaled
    
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon("core/widgets/icons/kfm_home.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Home"

  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.image=QtGui.QLabel(self)
    self.image.setAlignment(QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter)
    
    self.settings=QtCore.QSettings("auimd", "Home")
    path=self.settings.value("Wallpaper/path", QtCore.QVariant("wallpapers/demideuil.jpg")).toString()
    scaled=self.settings.value("Wallpaper/scaled", QtCore.QVariant("0")).toBool()
    self.setWallpaper(path, scaled)

    self.left_button.setText("Menu")
    self.right_button.setText("Exit")

    self.mainmenu=None

  def mainmenuDestroyed(self, o):
    self.mainmenu=None

  def leftButtonAction(self):
    if not self.mainmenu:
      self.mainmenu=MainMenu(self.desktop.content)
      self.connect(self.mainmenu, QtCore.SIGNAL("destroyed(QObject*)"), self.mainmenuDestroyed)
    self.desktop.showWidget(self.mainmenu)

  def rightButtonAction(self):
    self.desktop.exit()

  def keyboardAllowed(self):
    return 0

  def setWallpaper(self, path, scaled):
    pixmap=QtGui.QPixmap(path)
    self.image.setPixmap(pixmap)
    self.image.setScaledContents(scaled)
    self.settings.setValue("Wallpaper/path", QtCore.QVariant(path))
    self.settings.setValue("Wallpaper/scaled", QtCore.QVariant(scaled))
    self.wallpaper=Home.Wallpaper(path, scaled)

  def resizeEvent(self, e):
    self.image.resize(e.size())
