import time
from PyQt4 import QtCore, QtGui


class XEmbedWidget(QtGui.QX11EmbedContainer):
  def __init__(self, parent, name, program, args):
    QtGui.QX11EmbedContainer.__init__(self, parent)

    self.name=name
    self.program=program
    self.args=args[:]

    self.process=None
    self.state=0 # 0:not started, 1:loading, 2:embeded, 3:error, 4:ended

    QtCore.QObject.connect(self, QtCore.SIGNAL("clientIsEmbedded()"), self.clientIsEmbedded)

  def paintEvent(self, e):
    p=QtGui.QPainter(self)
    if self.state==1:
      p.drawText(self.rect(), QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter, "Loading "+self.name+"...")
    elif self.state==3:
      p.drawText(self.rect(), QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter, self.name+" failed to start.")
    elif self.state==4:
      p.drawText(self.rect(), QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter, self.name+" is terminated.")
    p.end()

  def showEvent(self, e):
    if not self.process and self.state==0:
      args=[]
      for a in self.args:
        s=a.replace("<winid>", str(self.winId()))
        s=s.replace("<width>", str(self.width()))
        s=s.replace("<height>", str(self.height()))
        args.append(s)
      
      self.process=QtCore.QProcess()
      QtCore.QObject.connect(self.process, QtCore.SIGNAL("finished(int, QProcess::ExitStatus)"), self.finished)
      self.process.start(self.program, args)

      # hack
      QtGui.QApplication.syncX()
      time.sleep(1)

      if self.process.waitForStarted():
        self.state=1
      else:
        self.process=None
        self.state=3

  def closeEvent(self, e):
    if self.process:
      QtCore.QObject.disconnect(self.process, QtCore.SIGNAL("finished(int, QProcess::ExitStatus)"), self.finished)
      self.process.terminate()
      self.process.waitForFinished(3000)
      self.process.kill()

  def finished(self, exit_code, exit_status):
    self.process=None
    self.state=4
    self.update()
    self.emit(QtCore.SIGNAL("finished()"))

  def clientIsEmbedded(self):
    self.state=2
    self.update()
