from PyQt4 import QtCore, QtGui, uic

from . import __path__
from core.auimd_widget import *

(Ui_Keyboard, BaseClass) = uic.loadUiType(__path__[0]+"/ui/keyboard.ui")

class Keyboard(BaseClass, Ui_Keyboard):
  MODE_DIALER=0
  MODE_PIN_CODE=1
  MODE_DTMF=2
  def __init__(self, parent, mode, init_value=""):
    BaseClass.__init__(self, parent)

    self.setupUi(self)
    self.display.setText(init_value)
    if mode==self.MODE_PIN_CODE:
      self.display.setEchoMode(QtGui.QLineEdit.PasswordEchoOnEdit)
      self.bt_star.setEnabled(False)
      self.bt_hash.setEnabled(False)
    elif mode==self.MODE_DTMF:
      self.bt_validate.hide()
      self.bt_bs.hide()
  
  def onButtonClicked(self):
    s=self.sender()
    if s is self.bt_validate:
      self.emit(QtCore.SIGNAL("validated"), self.display.text())
    elif s is self.bt_bs:
      self.display.setText(self.display.text()[:-1])
    else:
      self.display.setText(self.display.text()+s.text())
      self.emit(QtCore.SIGNAL("keyPressed"), self.sender().text())
