from PyQt4 import QtCore, QtGui

from . import __path__
from core.auimd_widget import *
from core.xembed_widget import *

class Terminal(QtGui.QWidget, AuimdWidget):
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon(__path__[0]+"/icons/terminal.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Terminal"

  @staticmethod
  def getCategory():
    return "System"

  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.embeded=XEmbedWidget(self, "mrxvt", "mrxvt", ("-into", "<winid>", "-geometry", "<width>x<height>"))
    self.connect(self.embeded, QtCore.SIGNAL("finished()"), self.finished)

    self.left_button.setText("")
    self.right_button.setText("Close")
  
  def showEvent(self, e):
    s=self.size()

  def resizeEvent(self, e):
    self.embeded.resize(e.size())

  def finished(self):
    self.desktop.closeWidget(self)

  def rightButtonAction(self):
    self.embeded.close()
    self.desktop.closeWidget(self)

  def closeEvent(self, e):
    self.embeded.close()
